<?php

namespace Drupal\datedeferfield\Plugin\views\filter;

use Drupal\datetime\Plugin\views\filter\Date;

/**
 * Date views filter adjusted for DateDeferField.
 *
 * @ingroup views_filter_handlers
 *
 * @ViewsFilter("datedeferfield_adjusted")
 */
class DateDeferFieldAdjusted extends Date {
  public function query() {
    parent::query(); // TODO: Change the autogenerated stub.

    // Dark magic.
    // @see \Drupal\views\Plugin\views\query\Sql::addWhereExpression
    /** @var \Drupal\views\Plugin\views\query\Sql $query */
    $query = $this->query;
    $conditions =& $query->where[$this->options['group']]['conditions'];
    $lastKey = key(array_slice($conditions, -1, 1, TRUE));
    $condition =& $conditions[$lastKey];
    $field =& $condition['field'];

    // If on of our date values is not provided, adjust it such that it is in
    // the far past.
    $field = "coalesce($field, '1970-01-01')";
  }

}
